<?php

use think\migration\Migrator;
use think\migration\db\Column;

class CreateProductCompat extends Migrator
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {
        $table = $this->table('product_compat', [
            'engine' => 'InnoDB',
            'collation' => 'utf8mb4_general_ci',
            'comment' => '产品兼容性表'
        ]);

        $table->addColumn('language_id', 'integer', ['signed' => false, 'null' => false, 'comment' => '语言ID'])
              ->addColumn('type_id', 'integer', ['signed' => false, 'null' => false, 'comment' => '类型id'])
              ->addColumn('part_id', 'integer', ['signed' => false, 'null' => false, 'comment' => '配件id'])
              ->addColumn('model', 'string', ['limit' => 128, 'null' => false, 'comment' => '型号'])
              ->addColumn('brand_name', 'string', ['limit' => 128, 'null' => false, 'comment' => '品牌'])
              ->addColumn('level_name', 'string', ['limit' => 128 , 'null' => true, 'comment' => '级别'])
              ->addColumn('spec_name', 'string', ['limit' => 128, 'null' => true, 'comment' => '规格'])
              ->addColumn('series_name', 'string', ['limit' => 128, 'null' => true, 'comment' => '系列'])
              ->addColumn('capacity', 'string', ['limit' => 32, 'null' => true, 'comment' => '容量'])
              ->addColumn('frequency', 'string', ['limit' => 128, 'null' => true, 'comment' => '频率'])
              ->addColumn('sort', 'integer', ['default' => 0, 'comment' => '排序'])
              ->addColumn('disabled', 'boolean', ['default' => 0, 'comment' => '是否禁用 0:启用 1:禁用'])
              ->addColumn('created_at', 'timestamp', ['null' => false, 'default' => 'CURRENT_TIMESTAMP', 'comment' => '创建时间'])
              ->addColumn('updated_at', 'timestamp', ['null' => false, 'default' => 'CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP', 'comment' => '更新时间'])
              ->addColumn('deleted_at', 'timestamp', ['null' => true, 'comment' => '删除时间'])
              ->addIndex(['language_id', 'model'], ['unique' => true])
              ->create();
    }
}
